unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, ssTreeView, ImgList, StdCtrls, ExtCtrls, Buttons;

type
  TForm1 = class(TForm)
    ImageList1: TImageList;
    ssTreeView1: TssTreeView;
    HeaderControl1: THeaderControl;
    Panel1: TPanel;
    btnStateIndex: TBitBtn;
    checkRoot: TCheckBox;
    btnCheck: TBitBtn;
    btnClear: TBitBtn;
    btnRevert: TBitBtn;
    checkRecurse: TCheckBox;
    btnSectionRects: TBitBtn;
    btnColor: TBitBtn;
    ColorDialog1: TColorDialog;
    checkRowSelect: TCheckBox;
    checkHideSelection: TCheckBox;
    Edit1: TEdit;
    procedure btnStateIndexClick(Sender: TObject);
    procedure btnCheckClick(Sender: TObject);
    procedure btnClearClick(Sender: TObject);
    procedure btnRevertClick(Sender: TObject);
    procedure btnSectionRectsClick(Sender: TObject);
    procedure ssTreeView1SectionBeforePaint(Sender: TssTreeView;
      Node: TssTreeNode; ItemRect: TRect; Section: Word);
    procedure btnColorClick(Sender: TObject);
    procedure checkRowSelectClick(Sender: TObject);
    procedure checkHideSelectionClick(Sender: TObject);
    procedure ssTreeView1NodeChecked(Sender: TssTreeView;
      Node: TssTreeNode);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses Unit2;

{$R *.DFM}

procedure TForm1.btnStateIndexClick(Sender: TObject);
begin
  with ssTreeView1 do
    if Self.checkRoot.Checked then SetCheckStateRoot else TssTreeNode(Selected).SetCheckState;
end;

procedure TForm1.btnCheckClick(Sender: TObject);
begin
  with ssTreeView1 do
    if Self.checkRoot.Checked then CheckRoot(checkRecurse.Checked) else TssTreeNode(Selected).Check(checkRecurse.Checked);
end;

procedure TForm1.btnClearClick(Sender: TObject);
begin
  with ssTreeView1 do
    if Self.checkRoot.Checked then UnCheckRoot(checkRecurse.Checked) else TssTreeNode(Selected).UnCheck(checkRecurse.Checked);
end;

procedure TForm1.btnRevertClick(Sender: TObject);
begin
  with ssTreeView1 do
    if Self.checkRoot.Checked then RevertRoot(checkRecurse.Checked) else TssTreeNode(Selected).Revert(checkRecurse.Checked);
end;

procedure TForm1.btnSectionRectsClick(Sender: TObject);
begin
  with ssTreeView1 do if (Selected <> nil) then ExecuteSections(TssTreeNode(Selected));
end;

procedure TForm1.ssTreeView1SectionBeforePaint(Sender: TssTreeView;
  Node: TssTreeNode; ItemRect: TRect; Section: Word);
begin
  Exit;
  if (Section = 1) then Sender.Canvas.Brush.Color := clRed;
  if (Section = 2) then Sender.Canvas.Font.Color := clBlue;
end;

procedure TForm1.btnColorClick(Sender: TObject);
begin
  with ColorDialog1 do begin
    Color := ssTreeView1.Color;
    if Execute then ssTreeView1.Color := Color;
  end;
end;

procedure TForm1.checkRowSelectClick(Sender: TObject);
begin
  ssTreeView1.RowSelect := checkRowSelect.Checked;
  ssTreeView1.Invalidate;
end;

procedure TForm1.checkHideSelectionClick(Sender: TObject);
begin
  ssTreeView1.HideSelection := checkHideSelection.Checked;
  ssTreeView1.Invalidate;
end;

procedure TForm1.ssTreeView1NodeChecked(Sender: TssTreeView;
  Node: TssTreeNode);
begin
  MessageDlg('State changed - '+node.Text, mtInformation, [mbOK], 0);
end;

end.
